"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ReportViewer;
exports.Template = void 0;

var _react = _interopRequireWildcard(require("react"));

var _dom = _interopRequireDefault(require("./renderer/dom"));

var _reportRenderer = _interopRequireDefault(require("./renderer/report-renderer"));

var _reportUiFeatures = _interopRequireDefault(require("./renderer/report-ui-features"));

var _templates = _interopRequireDefault(require("./templates"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Template = function Template() {
  return /*#__PURE__*/_react.default.createElement("div", {
    dangerouslySetInnerHTML: {
      __html: _templates.default
    }
  });
}; // return features to re-use


exports.Template = Template;

var generateReport = function generateReport(json, id) {
  var dom = new _dom.default(document);
  var renderer = new _reportRenderer.default(dom);
  var container = document.querySelector("#".concat(id));
  renderer.renderReport(json, container);
  var features = new _reportUiFeatures.default(dom);
  features.initFeatures(json);
  return features;
};

function ReportViewer(_ref) {
  var _ref$id = _ref.id,
      id = _ref$id === void 0 ? 'react-lighthouse-viewer' : _ref$id,
      _ref$json = _ref.json,
      json = _ref$json === void 0 ? {} : _ref$json;
  (0, _react.useEffect)(function () {
    var exist = json && Object.keys(json).length !== 0;
    var features = exist && generateReport(json, id);
    return function () {
      if (features) {
        features.dropFeatures();
      }
    };
  }, [json, id]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "lh-root lh-vars"
  }, /*#__PURE__*/_react.default.createElement(Template, null), /*#__PURE__*/_react.default.createElement("div", {
    id: id
  }));
}